from Functions import *

colors = select_color(2)

# Command line argument testing
if len(sys.argv) != 3:
    print "Inputs must be a data file and FlopsPerByte ratio."
    exit(1)

filename = sys.argv[1]
if not os.path.isfile(filename):
    print filename, "is not a valid input file."
    exit(1)

RatioFlopPerByte = 0.0
try:
    RatioFlopPerByte = float(sys.argv[2])
    print "FlopsPerByte: ", RatioFlopPerByte
except ValueError:
    print "Warning, the FlopsPerByte ratio must be a float"
    RatioFlopsPerByte = 0.0


maxy = 0
with open(filename, "r") as f:
    data = [line for line in f if test_line(line)]
    CoresUsed = [int(line.split()[0]) for line in data]
    MemoryUsed = [int(line.split()[1]) for line in data]
    BytePerCycle = [float(line.split()[2]) for line in data]
    FlopPerByte = [float(line.split()[3]) for line in data]
    TotalBytePerCycle = [x*y for x,y in zip(BytePerCycle, CoresUsed)]
    TotalGBytePerSec = [3.3*x for x in TotalBytePerCycle]
    AnalyticFLOPS = [RatioFlopPerByte * x for x in TotalGBytePerSec]
    case = 1

    FpB = [x for x, y in zip(FlopPerByte, CoresUsed) if y == case]
    AF = [x for x, y in zip(AnalyticFLOPS, CoresUsed) if y == case]
    Mu = [x for x, y in zip(MemoryUsed, CoresUsed) if y == case]
    Peak = [ 3.3 * 8 for _x in Mu]
    PercentageOfPeak = [100*x/y for x, y in zip(AF, Peak)]

    with open("report.txt","w") as out:
       out.write("Performance Report:\n")
       out.write("Memory\tGFLOPs\t%ofPeak\n")
       for memory, flops, percent in zip(Mu,AF,PercentageOfPeak):
          out.write("%s\t%.1f\t%.1f\n" % ( bytes_to_human(memory),flops,percent))
